/**
* @file     A31G32x_hal_libcfg.h
* @brief    Contains all macro definitions and function prototypes support
*           for libcfg on A31G32x
* @author	PTS Team, ABOV Semiconductor Co., Ltd.
* @date		15. OCT. 2019
* @version	1.0
*
* Copyright(C) 2019, ABOV Semiconductor
* All rights reserved.
*
*
********************************************************************************
* DISCLAIMER 
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
* TIME. AS A RESULT, ABOV SEMICONDUCTOR DISCLAIMS ALL LIABILITIES FROM ANY
* DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
* FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
* CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*
*/

#ifndef _A31G32x_LIBCFG_H_
#define _A31G32x_LIBCFG_H_


/******************* PERIPHERAL FW LIBRARY CONFIGURATION DEFINITIONS ***********************/
/* Comment the line below to disable the specific peripheral inclusion */

/*******************************************************************************
* Included File
*******************************************************************************/
 /* Un-comment the line below to compile the library in DEBUG mode, this will expanse
 the "CHECK_PARAM" macro in the FW library code */
 
//#define	USE_FULL_ASSERT
	
 /* DEBUG_FRAMWORK ------------------------------ */
#define _DEBUG_MSG
	
///* SYSTICK --------------------------- */
//#define _SYSTICK

///* GPIO ------------------------------- */
//#define _GPIO

///* ADC ------------------------------- */
//#define _ADC

///* COMP -------------------------------- */
//#define _COMP

///* CRC -------------------------------- */
//#define _CRC

///* DAC -------------------------------- */
//#define _DAC

///* EBI --------------------------------- */
//#define _EBI


///* WDT --------------------------------- */
//#define _WDT

///* TIMER ------------------------------- */
//#define _TIMER

///* USART ------------------------------- */
//#define _USART
//#define _USART0
//#define _USART1
//#define _USART2
//#define _USART3
//#define _USART4
//#define _USART5

///* SPI ------------------------------- */
//#define _SPI

///* I2C ------------------------------- */
//#define _I2C

///* USB ------------------------------- */
//#define _USB

///* WT ------------------------------- */
//#define _WT

///* RNG ------------------------------- */
//#define _RNG

///* RTC ------------------------------- */
//#define _RTC

///* TS ------------------------------- */
//#define _TS

///* CAN ------------------------------- */
//#define _CAN



/*******************************************************************************
* Public Macro
*******************************************************************************/
#ifdef  USE_FULL_ASSERT
/*******************************************************************************
* @brief                The CHECK_PARAM macro is used for function's parameters check.
*                               It is used only if the library is compiled in DEBUG mode.
* @param	    		expr - If expr is false, it calls check_failed() function
*                       which reports the name of the source file and the source
*                       line number of the call that failed.
*                    - If expr is true, it returns no value.
* @return               None
*******************************************************************************/
#define CHECK_PARAM(expr) ((expr) ? (void)0 : check_failed((uint8_t *)__FILE__, __LINE__))
#else
#define CHECK_PARAM(expr)
#endif 

/*******************************************************************************
* Public Typedef
*******************************************************************************/
 
 
/*******************************************************************************
* Exported Public Function
*******************************************************************************/
#ifdef  USE_FULL_ASSERT
void check_failed(uint8_t *file, uint32_t line);
#endif

#endif


