/**
* @file     A31G32x_hal_pwr.h
* @brief    Contains all macro definitions and function prototypes support
*           for pwr driver on A31G32x
* @author	PTS Team, ABOV Semiconductor Co., Ltd.
* @date		15. OCT. 2019
* @version	1.0
*
* Copyright(C) 2019, ABOV Semiconductor
* All rights reserved.
*
*
********************************************************************************
* DISCLAIMER 
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
* TIME. AS A RESULT, ABOV SEMICONDUCTOR DISCLAIMS ALL LIABILITIES FROM ANY
* DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
* FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
* CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*
*/

#ifndef _PWR_H_
#define _PWR_H_

/*******************************************************************************
* Included File
*******************************************************************************/
#include "A31G32x.h"
#include "A31G32x_hal_aa_types.h"\

#ifdef __cplusplus
extern "C"
{
#endif
/*******************************************************************************
* Public Macro
*******************************************************************************/

/*******************************************************************************
* Public Typedef
*******************************************************************************/



/*******************************************************************************
* Exported Public Function
*******************************************************************************/
void HAL_PWR_EnterSleepMode(void);
void HAL_PWR_EnterPowerDownMode(void);
void HAL_PWR_EnterStandbyMode(void);
void HAL_PWR_Backup_Power_Mode(FunctionalState state);
void HAL_PWR_StandbyMode_PC13_Wakeup(FunctionalState state);
Bool HAL_PC13_Wakeup_State(void);
void HAL_Backup_Register_Write(uint32_t value, uint8_t number);	
uint32_t HAL_Backup_Register_Read(uint8_t number);	
Bool HAL_Backup_Power_Wakeup_State(void);
	
#ifdef __cplusplus
}
#endif

#endif /* _A31G324_PWR_H_ */
/* --------------------------------- End Of File ------------------------------ */
