/**
* @file     A31G32x_hal_timer_common.h
* @brief    Contains all macro definitions and function prototypes support
*           for all timer common driver on A31G32x
* @author	PTS Team, ABOV Semiconductor Co., Ltd.
* @date		15. OCT. 2019
* @version	1.0
*
* Copyright(C) 2019, ABOV Semiconductor
* All rights reserved.
*
*
********************************************************************************
* DISCLAIMER 
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
* TIME. AS A RESULT, ABOV SEMICONDUCTOR DISCLAIMS ALL LIABILITIES FROM ANY
* DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
* FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
* CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*
*/

/*******************************************************************************
* TIMER(1n, 2n, 40) Common Typedef 
*******************************************************************************/

#ifdef __cplusplus
extern "C"
{
#endif

#ifndef _TIMERCOMMON_H_
#define _TIMERCOMMON_H_

/** @brief Timer operating mode */
typedef enum
{
	PERIODIC_MODE = 0,			/*!< PERIODIC mode */
	CAPTURE_MODE,				/*!< PWM mode */
	ONESHOT_MODE,				/*!< ONE SHOT mode */
	PWM_MODE					/*!< CAPTURE mode */
} TIMER_MODE_OPT;

/** @brief clear select when capture mode */
typedef enum
{
	FALLING_EGDE = 0,				/*!< rising edge clear mode */
	RISING_EGDE,					/*!< falling edge clear mode */
	BOTH_EGDE,					/*!< both edge clear  mode */
	NONE						/*!< none clear mode */
} TIMER_CLR_MODE_OPT;

/** @brief start default level select: initial output value. */
typedef enum
{
	START_HIGH = 0,				/*!< clock source from pclk div 2 */
	START_LOW					/*!< clock source from pclk div 4 */
} TIMER_STARTLVL_OPT;


#ifdef __cplusplus
}
#endif

#endif /*_TIMERCOMMON_H_*/
