/**
* @file     A31G32x_hal_usb_core.h
* @brief    Contains all macro definitions and function prototypes support
*           for usb core driver on A31G32x
* @author	PTS Team, ABOV Semiconductor Co., Ltd.
* @date		15. OCT. 2019
* @version	1.0
*
* Copyright(C) 2019, ABOV Semiconductor
* All rights reserved.
*
*
********************************************************************************
* DISCLAIMER 
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
* TIME. AS A RESULT, ABOV SEMICONDUCTOR DISCLAIMS ALL LIABILITIES FROM ANY
* DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
* FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
* CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*
*/

#ifndef _USB_CORE_H_
#define _USB_CORE_H_
/*******************************************************************************
* Included File
*******************************************************************************/
#include "A31G32x_hal_aa_types.h"

/*******************************************************************************
* Public Macro
*******************************************************************************/

/*******************************************************************************
* Public Typedef
*******************************************************************************/

/*******************************************************************************
* Exported Public Function
*******************************************************************************/

void USB_CoreInit(void);

void USB_prepareSetupPacket(void);

uint16_t USB_GetWakeupStatus(void);

void USB_OEPInt_DAINT_OutEPInt0(void);
void USB_OEPInt_DAINT_OutEPInt1(void);
void USB_IEPInt_DAINT_InEPInt0(void);
void USB_IEPInt_DAINT_InEPInt1(void);
#endif
