/**********************************************************************
* @file		A31G32x_it.c
* @brief	Contains all macro definitions and function prototypes
* 			support for PCU firmware library
* @author	ABOV Semiconductor Co., Ltd.
* @date		15. OCT. 2019
* @version	1.0
*
* Copyright(C) 2019, ABOV Semiconductor. All rights reserved.
* All rights reserved.
*
**********************************************************************/
#include "main_conf.h"
#include "A31G32x_it.h"
#include "debug_usartn.h"


/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
extern void SysTick_Handler_IT(void);
/* Private variables ---------------------------------------------------------*/


/******************************************************************************/
/*            Cortex M4 Processor Exceptions Handlers                         */
/******************************************************************************/

/**********************************************************************
 * @brief		This function handles NMI exception.
 * @param[in]	None
 * @return 		None
 **********************************************************************/
void NMI_Handler(void)
{
}


/**********************************************************************
 * @brief		This function handles Hard Fault exception.
 * @param[in]	None
 * @return 		None
 **********************************************************************/
void HardFault_Handler(void)
{
  /* Go to infinite loop when Hard Fault exception occurs */
  while (1)
  {
  }
}


/**********************************************************************
 * @brief		This function handles SVCall exception
 * @param[in]	None
 * @return 		None
 **********************************************************************/
void SVC_Handler(void)
{
}

/**********************************************************************
 * @brief		This function handles PendSVC exception
 * @param[in]	None
 * @return 		None
 **********************************************************************/
void PendSV_Handler(void)
{
}

/**********************************************************************
 * @brief		This function handles SysTick Handler.
 * @param[in]	None
 * @return 		None
 **********************************************************************/
void SysTick_Handler(void)
{
	SysTick_Handler_IT();
}

/**********************************************************************
 * @brief		This function handles USART Handler.
 * @param[in]	None
 * @return	None
 **********************************************************************/

void	USART10_IRQHandler(void)
{
	USART_Handler(USART10);
}

void	USART11_IRQHandler(void)
{
	USART_Handler(USART11);
}

void	USART12_IRQHandler(void)
{
	USART_Handler(USART12);
}

void	USART13_IRQHandler(void)
{
	USART_Handler(USART13);
}


/******************************************************************************/
/*                 A31G32x Peripherals Interrupt Handlers                     */
/*  Add here the Interrupt Handler for the used peripheral(s) (PPP), for the  */
/*  available peripheral interrupt handler's name please refer to the startup */
/*  file (startup_A31G32x.s).                                                 */
/******************************************************************************/

