/**
* @file		Debug.c
* @brief	Contains all functions support for usart firmware library on A31G324
* @author	ABOV Semiconductor Co., Ltd.
* @date		15. OCT. 2019
* @version	1.0
*
* Copyright(C) 2019, ABOV Semiconductor
* All rights reserved.
*
********************************************************************************
* DISCLAIMER 
*
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
* TIME. AS A RESULT, ABOV SEMICONDUCTOR DISCLAIMS ALL LIABILITIES FROM ANY
* DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
* FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
* CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*
*/

/*******************************************************************************
* Included File
*******************************************************************************/
#include <stdint.h>
#include "debug_frmwrk.h"

/*******************************************************************************
* Private Pre-processor Definition & Macro
*******************************************************************************/

/*******************************************************************************
* Private Typedef
*******************************************************************************/

/*******************************************************************************
* Private Function Prototype
*******************************************************************************/
int clear_variables(int32_t);

/*******************************************************************************
* Private Variable
*******************************************************************************/
char	var_a;
char	var_b;
int32_t	_msec;
int32_t	count;

DEBUG_VARIABLES dbg_variables[] = {
	{	1,	"a", (void*)&var_a,	0	},
	{	1,	"b", (void*)&var_a,	0	},
	{	4,	"msec", (void*)&_msec,	0	},
	{	4,	"count", (void*)&count,	0	},
	{	0,	"clear", (void*)clear_variables, 0	},
	{	-1,	"",		(void*)NULL,	0	}
};

/*********************************************************************
 * @brief		clear_variables
 * @param[in]	int32_t arg
 * @return 	int
 **********************************************************************/
int clear_variables(int32_t arg)
{
	cprintf("a = %d, b = %d\r\nmsec = %d, count = %d\r\n", var_a, var_b, _msec, count);

	// clear variables
	return 0;	// ??
}



