/**********************************************************************
* @file		EEPROM.h
* @brief	Contains all macro definitions and function prototypes
* 			support for PCU firmware library on A31G324
* @version	1.0
* @date		2018.08.13
* @author	ABOV Application team
*
* Copyright(C) 2018, ABOV Semiconductor
* All rights reserved.
*
**********************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef _EEPROM_H_
#define _EEPROM_H_

/*******************************************************************************
* Included File
*******************************************************************************/
#include "A31G32x.h"
#include "A31G32x_hal_aa_types.h"

#ifdef __cplusplus
extern "C"
{
#endif

/*******************************************************************************
* Public Macro
*******************************************************************************/
#define	CS_L	PA->OUTDR &= ~(1<<1)
#define	CS_H	PA->OUTDR |= (1<<1)
#define	PAGE_SIZE	32

/*******************************************************************************
* Public Typedef
*******************************************************************************/

/*******************************************************************************
* Exported Public Function
*******************************************************************************/
void EEPROM_Init(void);
void EEPROM_Write_Byte(uint16_t addr, uint8_t data);
uint8_t EEPROM_Read_Byte(uint16_t addr);
void EEPROM_Erase_Byte(uint16_t addr);
void EEPROM_Write_Page(uint16_t addr, uint8_t* data);
void EEPROM_Read_Page(uint16_t addr, uint8_t* data);
void EEPROM_Erase_Page(uint16_t addr);

#ifdef __cplusplus
}
#endif

#endif /* end _EEPROM_H_ */
