#include "A31G32x_hal_usb_core.h"
#include "A31G32x_usb_user.h"
#include "stdio.h"
#include "a31g32x.h"

volatile uint32_t   USB_DOEP1_DMA_DESC_RX[2];
volatile uint32_t   USB_DOEP1_DMA_BUF_RX[64];
volatile uint32_t   USB_DIEP1_DMA_DESC_TX[2];
volatile uint32_t   USB_DIEP1_DMA_BUF_TX[64];




void USB_Send_HID_Report_EP1(uint8_t *ch){

	uint8_t* report;
	
	report = ch;
	
	USB_DIEP1_DMA_DESC_TX[0] = 0x0A000000 | 0x40;	//1Byte
  USB_DIEP1_DMA_DESC_TX[1] = (uint32_t)report;
        
  USB->DIEPDMA1 = (uint32_t)USB_DIEP1_DMA_DESC_TX;
	
	USB->DIEPCTL1 |= (0x40   <<  0); //1Byte
	USB->DIEPCTL1 |= (0x1   << 26); //CNAK
	USB->DIEPCTL1 |= (0x1UL << 31); //EPEna

//	while(!(((USB_DIEP1_DMA_DESC_TX[0] >> 30) & 0x3) == 0x3
//		|| ((USB_DIEP1_DMA_DESC_TX[0] >> 30) & 0x3) == 0x2)){}
}

void USB_Receive_HID_Report_EP1(uint8_t *ch){
	
	USB_DOEP1_DMA_DESC_RX[0] = 0x0A000000 | 0x40;	//1Byte
	USB_DOEP1_DMA_DESC_RX[1] = (uint32_t)ch;
        
   USB->DOEPDMA1 = (uint32_t)USB_DOEP1_DMA_DESC_RX;
	
	USB->DOEPCTL1 |= (0x40   <<  0); //1Byte
	USB->DOEPCTL1 |= (0x1   << 26); //CNAK
	USB->DOEPCTL1 |= (0x1UL << 31); //EPEna
}

void USB_Remote_Wakeup_Signal()
{
		if(USB_GetWakeupStatus())
		{
				USB->DCTL |= (1<<0);
		}
}
