#include "A31G32x_usb_user.h"
#include "stdio.h"
#include "a31g32x.h"
#include "A31G32x_hal_usartn.h"

volatile uint32_t   USB_DOEP1_DMA_DESC_RX[2];
volatile uint32_t   USB_DOEP1_DMA_BUF_RX[64];
volatile uint32_t   USB_DIEP1_DMA_DESC_TX[2];
volatile uint32_t   USB_DIEP1_DMA_BUF_TX[64];

volatile uint32_t   USB_DIEP2_DMA_DESC_TX[2];
volatile uint32_t   USB_DIEP2_DMA_BUF_TX[64];

volatile uint32_t   USB_EP1_status = 0;

volatile tCdc_line_coding _cdc_line_coding;



void USB_Send_DATA_EP1(uint8_t ch){
	volatile uint32_t timeout;
	USB_DIEP1_DMA_DESC_TX[0] = 0x0A000000 | 0x1;	//1Byte
	USB_DIEP1_DMA_DESC_TX[1] = (uint32_t)&ch;
	
	USB->DIEPDMA1 = (uint32_t)USB_DIEP1_DMA_DESC_TX;
	
	USB->DIEPCTL1 |= (0x1   <<  0); //1Byte
	USB->DIEPCTL1 |= (0x1   << 26); //CNAK
	USB->DIEPCTL1 |= (0x1UL << 31); //EPEna
	timeout = 10000;
	while(!(((USB_DIEP1_DMA_DESC_TX[0] >> 30) & 0x3) == 0x3
		|| ((USB_DIEP1_DMA_DESC_TX[0] >> 30) & 0x3) == 0x2)){if(!(timeout--)) break;}
}

void USB_Receive_DATA_EP1(uint8_t *ch){
	USB_DOEP1_DMA_DESC_RX[0] = 0x0A000000 | 0x40;	//1Byte
	USB_DOEP1_DMA_DESC_RX[1] = (uint32_t)ch;
		
	USB->DOEPDMA1 = (uint32_t)USB_DOEP1_DMA_DESC_RX;
	
	USB->DOEPCTL1 |= (0x40  <<  0); //1Byte
	USB->DOEPCTL1 |= (0x1   << 26); //CNAK
	USB->DOEPCTL1 |= (0x1UL << 31); //EPEna
}

void Process_line_coding(void){

	USART_CFG_Type USART_InitStruct;	

    USART_InitStruct.Mode = USART_UART_MODE;
	USART_InitStruct.Baud_rate = _cdc_line_coding.bitrate;
	switch(_cdc_line_coding.datatype){
		case 5:
			USART_InitStruct.Databits = USART_DATABIT_5;
			break;
		case 6:
			USART_InitStruct.Databits = USART_DATABIT_6;
			break;
		case 7:
			USART_InitStruct.Databits = USART_DATABIT_7;
			break;
		case 9:
			USART_InitStruct.Databits = USART_DATABIT_9;
			break;
		case 8:
		default:
			USART_InitStruct.Databits = USART_DATABIT_8;
			break;
	}
	
	switch(_cdc_line_coding.paritytype){
		case 1:
			USART_InitStruct.Parity = USART_PARITY_ODD;
			break;
		case 2:
			USART_InitStruct.Parity = USART_PARITY_EVEN;
			break;
		case 0:
		default:
			USART_InitStruct.Parity = USART_PARITY_NONE;
			break;
	}
	
	switch(_cdc_line_coding.format){
		case 2:
			USART_InitStruct.Stopbits = USART_STOPBIT_2;
			break;
		case 0:
		default:
			USART_InitStruct.Stopbits = USART_STOPBIT_1;
			break;
	}
	
	HAL_USART_Init(USART10, &USART_InitStruct);

}

uint8_t Get_rx_length(void)
{
	return CDC_DATA_FS_MAX_PACKET_SIZE - (USB_DOEP1_DMA_DESC_RX[0] & 0xffff);
}
